import java.awt.*;
import java.awt.event.*;
import javax.swing.JPanel;
import javax.swing.BorderFactory;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.ButtonGroup;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.JRadioButton;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.JApplet;

public class LZW_Applet extends JApplet implements ActionListener {
	static LZW_Applet theLZW_Applet;

	JPanel pnPanel0;
	ButtonGroup rbgPanel0;
	ButtonGroup rbgPanel1;
	JList lsLDictionary;
	JList lsLOutput;
	JRadioButton rbRLZW;
	JRadioButton rbRLZ77;
	JRadioButton rbRAlpha1;
	JRadioButton rbRAlpha2;
	JButton btBtnReset;
	JButton btBtnStep;
	JTextField tfText0;
	JLabel lbLblError;
	JLabel lbLblType;
	JLabel lbLblAlpha;
	LZWx  DataGiver;
	boolean initComplete = false;
	
	public static void main(String args[]) {
		theLZW_Applet = new LZW_Applet();
		
	}

	public LZW_Applet() {
		super();

		Dimension panelMinSize = new Dimension();
		panelMinSize.height = 40;
		panelMinSize.width  = 40;
		Dimension panelMaxSize = new Dimension();
		panelMaxSize.height = 480;
		panelMaxSize.width  = 480;
		pnPanel0 = new JPanel();
		rbgPanel0 = new ButtonGroup();
		rbgPanel1 = new ButtonGroup();
		GridBagLayout gbPanel0 = new GridBagLayout();
		GridBagConstraints gbcPanel0 = new GridBagConstraints();
		pnPanel0.setLayout(gbPanel0);
		pnPanel0.setMinimumSize(panelMinSize);
		pnPanel0.setMaximumSize(panelMaxSize);

		String[] sLDictionary = { "Wrterbuch" };
		lsLDictionary = new JList(sLDictionary);
		lsLDictionary.setAutoscrolls(true);
		JScrollPane scpLDictionary = new JScrollPane(lsLDictionary);
		gbcPanel0.gridx = 0;
		gbcPanel0.gridy = 0;
		gbcPanel0.gridwidth = 16;
		gbcPanel0.gridheight = 38;
		gbcPanel0.fill = GridBagConstraints.BOTH;
		gbcPanel0.weightx = 1;
		gbcPanel0.weighty = 1;
		gbcPanel0.anchor = GridBagConstraints.NORTH;
		gbPanel0.setConstraints(scpLDictionary, gbcPanel0);
		pnPanel0.add(scpLDictionary);

		String[] sLOutput = { "Ausgabe" };
		lsLOutput = new JList(sLOutput);
		lsLOutput.setAutoscrolls(true);
		gbcPanel0.gridx = 16;
		gbcPanel0.gridy = 0;
		gbcPanel0.gridwidth = 14;
		gbcPanel0.gridheight = 34;
		gbcPanel0.fill = GridBagConstraints.BOTH;
		gbcPanel0.weightx = 1;
		gbcPanel0.weighty = 1;
		gbcPanel0.anchor = GridBagConstraints.NORTH;
		gbPanel0.setConstraints(lsLOutput, gbcPanel0);
		pnPanel0.add(lsLOutput);

		rbRLZW = new JRadioButton("LZW");
		rbRLZW.setSelected(true);		
		rbgPanel0.add(rbRLZW);
		gbcPanel0.gridx = 30;
		gbcPanel0.gridy = 2;
		gbcPanel0.gridwidth = 10;
		gbcPanel0.gridheight = 2;
		gbcPanel0.fill = GridBagConstraints.BOTH;
		gbcPanel0.weightx = 1;
		gbcPanel0.weighty = 0;
		gbcPanel0.anchor = GridBagConstraints.NORTH;
		gbPanel0.setConstraints(rbRLZW, gbcPanel0);
		pnPanel0.add(rbRLZW);
		
		rbRLZ77 = new JRadioButton( "LZ77" );
		rbRLZ77.setSelected( true );
		rbgPanel0.add( rbRLZ77 );
		gbcPanel0.gridx = 30;
		gbcPanel0.gridy = 4;
		gbcPanel0.gridwidth = 10;
		gbcPanel0.gridheight = 4;
		gbcPanel0.fill = GridBagConstraints.BOTH;
		gbcPanel0.weightx = 1;
		gbcPanel0.weighty = 0;
		gbcPanel0.anchor = GridBagConstraints.NORTH;
		gbPanel0.setConstraints( rbRLZ77, gbcPanel0 );
		pnPanel0.add( rbRLZ77 );

		rbRAlpha1 = new JRadioButton("A,B,C");
		rbRAlpha1.setSelected(true);
		rbgPanel1.add(rbRAlpha1);
		gbcPanel0.gridx = 30;
		gbcPanel0.gridy = 12;
		gbcPanel0.gridwidth = 10;
		gbcPanel0.gridheight = 4;
		gbcPanel0.fill = GridBagConstraints.BOTH;
		gbcPanel0.weightx = 1;
		gbcPanel0.weighty = 0;
		gbcPanel0.anchor = GridBagConstraints.NORTH;
		gbPanel0.setConstraints(rbRAlpha1, gbcPanel0);
		pnPanel0.add(rbRAlpha1);

		rbRAlpha2 = new JRadioButton("A, ..Z, ' '");
		rbgPanel1.add(rbRAlpha2);
		gbcPanel0.gridx = 30;
		gbcPanel0.gridy = 16;
		gbcPanel0.gridwidth = 10;
		gbcPanel0.gridheight = 4;
		gbcPanel0.fill = GridBagConstraints.BOTH;
		gbcPanel0.weightx = 1;
		gbcPanel0.weighty = 0;
		gbcPanel0.anchor = GridBagConstraints.NORTH;
		gbPanel0.setConstraints(rbRAlpha2, gbcPanel0);
		pnPanel0.add(rbRAlpha2);

		btBtnReset = new JButton( "Reset" );
		btBtnReset.addActionListener(this);
		gbcPanel0.gridx = 30;
		gbcPanel0.gridy = 24;
		gbcPanel0.gridwidth = 10;
		gbcPanel0.gridheight = 2;
		gbcPanel0.fill = GridBagConstraints.BOTH;
		gbcPanel0.weightx = 1;
		gbcPanel0.weighty = 0;
		gbcPanel0.anchor = GridBagConstraints.NORTH;
		gbPanel0.setConstraints( btBtnReset, gbcPanel0 );
		pnPanel0.add( btBtnReset );

		btBtnStep = new JButton("Step");
		btBtnReset.setActionCommand("Button pushed");
		btBtnStep.addActionListener(this);
		gbcPanel0.gridx = 30;
		gbcPanel0.gridy = 28;
		gbcPanel0.gridwidth = 10;
		gbcPanel0.gridheight = 4;
		gbcPanel0.fill = GridBagConstraints.BOTH;
		gbcPanel0.weightx = 1;
		gbcPanel0.weighty = 0;
		gbcPanel0.anchor = GridBagConstraints.NORTH;
		gbPanel0.setConstraints(btBtnStep, gbcPanel0);
		pnPanel0.add(btBtnStep);

		tfText0 = new JTextField();
		tfText0.addActionListener(this);
		gbcPanel0.gridx = 16;
		gbcPanel0.gridy = 34;
		gbcPanel0.gridwidth = 24;
		gbcPanel0.gridheight = 4;
		gbcPanel0.fill = GridBagConstraints.BOTH;
		gbcPanel0.weightx = 1;
		gbcPanel0.weighty = 0;
		gbcPanel0.anchor = GridBagConstraints.NORTH;
		gbPanel0.setConstraints(tfText0, gbcPanel0);
		pnPanel0.add(tfText0);

		lbLblError = new JLabel("");
		gbcPanel0.gridx = 0;
		gbcPanel0.gridy = 38;
		gbcPanel0.gridwidth = 40;
		gbcPanel0.gridheight = 2;
		gbcPanel0.fill = GridBagConstraints.BOTH;
		gbcPanel0.weightx = 1;
		gbcPanel0.weighty = 1;
		gbcPanel0.anchor = GridBagConstraints.NORTH;
		gbPanel0.setConstraints(lbLblError, gbcPanel0);
		pnPanel0.add(lbLblError);

		lbLblType = new JLabel("Verfahren");
		gbcPanel0.gridx = 30;
		gbcPanel0.gridy = 0;
		gbcPanel0.gridwidth = 10;
		gbcPanel0.gridheight = 2;
		gbcPanel0.fill = GridBagConstraints.BOTH;
		gbcPanel0.weightx = 1;
		gbcPanel0.weighty = 1;
		gbcPanel0.anchor = GridBagConstraints.NORTH;
		gbPanel0.setConstraints(lbLblType, gbcPanel0);
		pnPanel0.add(lbLblType);

		lbLblAlpha = new JLabel( "Alphabet" );
		gbcPanel0.gridx = 30;
		gbcPanel0.gridy = 10;
		gbcPanel0.gridwidth = 10;
		gbcPanel0.gridheight = 2;
		gbcPanel0.fill = GridBagConstraints.BOTH;
		gbcPanel0.weightx = 1;
		gbcPanel0.weighty = 1;
		gbcPanel0.anchor = GridBagConstraints.NORTH;
		gbPanel0.setConstraints( lbLblAlpha, gbcPanel0 );
		pnPanel0.add( lbLblAlpha );
		
		setContentPane(pnPanel0);
		
		DataGiver = new LZWx();
	}
	public void actionPerformed(ActionEvent actionevent)
    {
		// Object obj;
		// String whatHappend = actionevent.getActionCommand();
		if (actionevent.getSource() == btBtnReset)
		{
			
			if (rbRAlpha1.isSelected())
				if (rbRLZW.isSelected())
					DataGiver.Reset(0, 1);
				else
					DataGiver.Reset(1, 1);
			else
				if (rbRLZW.isSelected())
					DataGiver.Reset(0, 0);
				else
					DataGiver.Reset(1, 0);
			initComplete = true;
		}
		if (actionevent.getSource() == btBtnStep)
		{
			if (DataGiver.running)
				lbLblError.setText(DataGiver.StepOn());
			else
				if (initComplete)
					//if (DataGiver.running)
						lbLblError.setText(DataGiver.FirstStep(tfText0.getText().toUpperCase()));
					//else
					//	lbLblError.setText("Engine stopped. Please reset.");
		}
		ShowDataGiver();
    }
	
	private void ShowDataGiver()
	{
		// lsLDictionary.set
		lsLDictionary.setListData(DataGiver.Woerterbuch.toArray());
		lsLOutput.setListData(DataGiver.Ausgabe.toArray());
		
	}
}
